/*
 * Copyright (c) 2005, 2017 IBM Corporation, Embarcadero Technologies, CEA, and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   IBM - initial API and implementation
 *   Kenn Hussey (Embarcadero Technologies) - 215418, 204200
 *   Kenn Hussey - 323181
 *   Kenn Hussey (CEA) - 327039, 418466, 414970, 370089, 511674
 *
 */
package org.eclipse.uml2.uml.edit.providers;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.UMLPackage;

/**
 * This is the item provider adapter for a {@link org.eclipse.uml2.uml.InteractionUse} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class InteractionUseItemProvider
		extends InteractionFragmentItemProvider {

	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InteractionUseItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addActualGatePropertyDescriptor(object);
			addArgumentPropertyDescriptor(object);
			addRefersToPropertyDescriptor(object);
			addReturnValuePropertyDescriptor(object);
			addReturnValueRecipientPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Refers To feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addRefersToPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
			((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(),
			getResourceLocator(),
			getString("_UI_InteractionUse_refersTo_feature"), //$NON-NLS-1$
			getString("_UI_PropertyDescriptor_description", //$NON-NLS-1$
				"_UI_InteractionUse_refersTo_feature", //$NON-NLS-1$
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			UMLPackage.Literals.INTERACTION_USE__REFERS_TO, true, false, true,
			null, null, null));
	}

	/**
	 * This adds a property descriptor for the Return Value feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addReturnValuePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
			((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(),
			getResourceLocator(),
			getString("_UI_InteractionUse_returnValue_feature"), //$NON-NLS-1$
			getString("_UI_PropertyDescriptor_description", //$NON-NLS-1$
				"_UI_InteractionUse_returnValue_feature", //$NON-NLS-1$
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE, true, false,
			true, null, null,
			new String[]{"org.eclipse.ui.views.properties.expert" //$NON-NLS-1$
		}));
	}

	/**
	 * This adds a property descriptor for the Return Value Recipient feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addReturnValueRecipientPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
			((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(),
			getResourceLocator(),
			getString("_UI_InteractionUse_returnValueRecipient_feature"), //$NON-NLS-1$
			getString("_UI_PropertyDescriptor_description", //$NON-NLS-1$
				"_UI_InteractionUse_returnValueRecipient_feature", //$NON-NLS-1$
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE_RECIPIENT, true,
			false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Actual Gate feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addActualGatePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
			((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(),
			getResourceLocator(),
			getString("_UI_InteractionUse_actualGate_feature"), //$NON-NLS-1$
			getString("_UI_PropertyDescriptor_description", //$NON-NLS-1$
				"_UI_InteractionUse_actualGate_feature", //$NON-NLS-1$
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			UMLPackage.Literals.INTERACTION_USE__ACTUAL_GATE, true, false, true,
			null, null, new String[]{"org.eclipse.ui.views.properties.expert" //$NON-NLS-1$
		}));
	}

	/**
	 * This adds a property descriptor for the Argument feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addArgumentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
			((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(),
			getResourceLocator(),
			getString("_UI_InteractionUse_argument_feature"), //$NON-NLS-1$
			getString("_UI_PropertyDescriptor_description", //$NON-NLS-1$
				"_UI_InteractionUse_argument_feature", //$NON-NLS-1$
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			UMLPackage.Literals.INTERACTION_USE__ARGUMENT, true, false, true,
			null, null, new String[]{"org.eclipse.ui.views.properties.expert" //$NON-NLS-1$
		}));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures
				.add(UMLPackage.Literals.INTERACTION_USE__ACTUAL_GATE);
			childrenFeatures.add(UMLPackage.Literals.INTERACTION_USE__ARGUMENT);
			childrenFeatures
				.add(UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns InteractionUse.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
			getResourceLocator().getImage("full/obj16/InteractionUse")); //$NON-NLS-1$
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String getText(Object object) {
		return appendLabel(
			appendType(appendKeywords(new StringBuffer(), object),
				"_UI_InteractionUse_type"), //$NON-NLS-1$
			object).toString();
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(InteractionUse.class)) {
			case UMLPackage.INTERACTION_USE__ACTUAL_GATE :
			case UMLPackage.INTERACTION_USE__ARGUMENT :
			case UMLPackage.INTERACTION_USE__RETURN_VALUE :
				fireNotifyChanged(new ViewerNotification(notification,
					notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__ACTUAL_GATE,
			UMLFactory.eINSTANCE.createGate()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createOpaqueExpression()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createExpression()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createStringExpression()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createInstanceValue()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createTimeExpression()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createDuration()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createInterval()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createDurationInterval()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralBoolean()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralInteger()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralNull()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralReal()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralString()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createLiteralUnlimitedNatural()));

		newChildDescriptors.add(
			createChildParameter(UMLPackage.Literals.INTERACTION_USE__ARGUMENT,
				UMLFactory.eINSTANCE.createTimeInterval()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createOpaqueExpression()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createExpression()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createStringExpression()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createInstanceValue()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createTimeExpression()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createDuration()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createInterval()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createDurationInterval()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralBoolean()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralInteger()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralNull()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralReal()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralString()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createLiteralUnlimitedNatural()));

		newChildDescriptors.add(createChildParameter(
			UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE,
			UMLFactory.eINSTANCE.createTimeInterval()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child,
			Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == UMLPackage.Literals.NAMED_ELEMENT__NAME_EXPRESSION
			|| childFeature == UMLPackage.Literals.INTERACTION_USE__ARGUMENT
			|| childFeature == UMLPackage.Literals.INTERACTION_USE__RETURN_VALUE;

		if (qualify) {
			return getString("_UI_CreateChild_text2", //$NON-NLS-1$
				new Object[]{getTypeText(childObject),
					getFeatureText(childFeature), getTypeText(owner)});
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}